//#define FAMILY_KEYBOARD
#define SUBOR_KEYBOARD

/*
#ifdef FAMILY_KEYBOARD

#define KBD_ROWS		9
#define KB_CODE(column,row,bit)		((((column)*KBD_ROWS+(row))<<8)|(0x20>>((bit))))

#define KB_R_BRACKET	KB_CODE(0,0,4)
#define KB_L_BRACKET	KB_CODE(0,0,3)
#define KB_RETURN		KB_CODE(0,0,2)
#define KB_F8			KB_CODE(0,0,1)

#define KB_SEMICOLON	KB_CODE(0,1,4)
#define KB_COLON		KB_CODE(0,1,3)
#define KB_AT			KB_CODE(0,1,2)
#define KB_F7			KB_CODE(0,1,1)

#define KB_K			KB_CODE(0,2,4)
#define KB_L			KB_CODE(0,2,3)
#define KB_O			KB_CODE(0,2,2)
#define KB_F6			KB_CODE(0,2,1)

#define KB_J			KB_CODE(0,3,4)
#define KB_U			KB_CODE(0,3,3)
#define KB_I			KB_CODE(0,3,2)
#define KB_F5			KB_CODE(0,3,1)

#define KB_H			KB_CODE(0,4,4)
#define KB_G			KB_CODE(0,4,3)
#define KB_Y			KB_CODE(0,4,2)
#define KB_F4			KB_CODE(0,4,1)

#define KB_D			KB_CODE(0,5,4)
#define KB_R			KB_CODE(0,5,3)
#define KB_T			KB_CODE(0,5,2)
#define KB_F3			KB_CODE(0,5,1)

#define KB_A			KB_CODE(0,6,4)
#define KB_S			KB_CODE(0,6,3)
#define KB_W			KB_CODE(0,6,2)
#define KB_F2			KB_CODE(0,6,1)

#define KB_CTR			KB_CODE(0,7,4)
#define KB_Q			KB_CODE(0,7,3)
#define KB_ESC			KB_CODE(0,7,2)
#define KB_F1			KB_CODE(0,7,1)

#define KB_LEFT			KB_CODE(0,8,4)
#define KB_RIGHT		KB_CODE(0,8,3)
#define KB_UP			KB_CODE(0,8,2)
#define KB_HOME			KB_CODE(0,8,1)

#define KB_STOP			KB_CODE(1,0,4)
#define KB_YEN			KB_CODE(1,0,3)
#define KB_RSHIFT		KB_CODE(1,0,2)
#define KB_KANA			KB_CODE(1,0,1)

#define KB_ARROW		KB_CODE(1,1,4)
#define KB_DASH			KB_CODE(1,1,3)
#define KB_SLASH		KB_CODE(1,1,2)
#define KB_UNDERSCORE	KB_CODE(1,1,1)

#define KB_0			KB_CODE(1,2,4)
#define KB_P			KB_CODE(1,2,3)
#define KB_COMMA		KB_CODE(1,2,2)
#define KB_DOT			KB_CODE(1,2,1)

#define KB_8			KB_CODE(1,3,4)
#define KB_9			KB_CODE(1,3,3)
#define KB_N			KB_CODE(1,3,2)
#define KB_M			KB_CODE(1,3,1)

#define KB_6			KB_CODE(1,4,4)
#define KB_7			KB_CODE(1,4,3)
#define KB_V			KB_CODE(1,4,2)
#define KB_B			KB_CODE(1,4,1)

#define KB_4			KB_CODE(1,5,4)
#define KB_5			KB_CODE(1,5,3)
#define KB_C			KB_CODE(1,5,2)
#define KB_F			KB_CODE(1,5,1)

#define KB_3			KB_CODE(1,6,4)
#define KB_E			KB_CODE(1,6,3)
#define KB_Z			KB_CODE(1,6,2)
#define KB_X			KB_CODE(1,6,1)

#define KB_2			KB_CODE(1,7,4)
#define KB_1			KB_CODE(1,7,3)
#define KB_GRPH			KB_CODE(1,7,2)
#define KB_LSHIFT		KB_CODE(1,7,1)

#define KB_INS			KB_CODE(1,8,4)
#define KB_DEL			KB_CODE(1,8,3)
#define KB_SPACE		KB_CODE(1,8,2)
#define KB_DOWN			KB_CODE(1,8,1)

#endif
*/


#ifdef SUBOR_KEYBOARD

#define KBD_ROWS		13
#define KB_CODE(column,row,bit)		((((column)*KBD_ROWS+(row))<<8)|(0x20>>(bit)))

#define KB_4			KB_CODE(0,0,4)
#define KB_G			KB_CODE(0,0,3)
#define KB_F			KB_CODE(0,0,2)
#define KB_C			KB_CODE(0,0,1)

#define KB_F2			KB_CODE(1,0,4)
#define KB_E			KB_CODE(1,0,3)
#define KB_5			KB_CODE(1,0,2)
#define KB_V			KB_CODE(1,0,1)

#define KB_2			KB_CODE(0,1,4)
#define KB_D			KB_CODE(0,1,3)
#define KB_S			KB_CODE(0,1,2)
#define KB_END			KB_CODE(0,1,1)

#define KB_F1			KB_CODE(1,1,4)
#define KB_W			KB_CODE(1,1,3)
#define KB_3			KB_CODE(1,1,2)
#define KB_X			KB_CODE(1,1,1)

#define KB_INS			KB_CODE(0,2,4)
#define KB_BACKSPACE	KB_CODE(0,2,3)
#define KB_PGDOWN		KB_CODE(0,2,2)
#define KB_RIGHT		KB_CODE(0,2,1)

#define KB_F8			KB_CODE(1,2,4)
#define KB_PGUP			KB_CODE(1,2,3)
#define KB_DEL			KB_CODE(1,2,2)
#define KB_HOME			KB_CODE(1,2,1)

#define KB_9			KB_CODE(0,3,4)
#define KB_I			KB_CODE(0,3,3)
#define KB_L			KB_CODE(0,3,2)
#define KB_COMMA		KB_CODE(0,3,1)

#define KB_F5			KB_CODE(1,3,4)
#define KB_O			KB_CODE(1,3,3)
#define KB_0			KB_CODE(1,3,2)
#define KB_DOT			KB_CODE(1,3,1)

#define KB_CLOSEBRACE	KB_CODE(0,4,4)
#define KB_RETURN		KB_CODE(0,4,3)
#define KB_UP			KB_CODE(0,4,2)
#define KB_LEFT			KB_CODE(0,4,1)

#define KB_F7			KB_CODE(1,4,4)
#define KB_OPENBRACE	KB_CODE(1,4,3)
#define KB_BACKSLASH	KB_CODE(1,4,2)
#define KB_DOWN			KB_CODE(1,4,1)

#define KB_Q			KB_CODE(0,5,4)
#define KB_CAPS			KB_CODE(0,5,3)
#define KB_Z			KB_CODE(0,5,2)
#define KB_TAB			KB_CODE(0,5,1)

#define KB_ESC			KB_CODE(1,5,4)
#define KB_A			KB_CODE(1,5,3)
#define KB_1			KB_CODE(1,5,2)
#define KB_CTRL			KB_CODE(1,5,1)

#define KB_7			KB_CODE(0,6,4)
#define KB_Y			KB_CODE(0,6,3)
#define KB_K			KB_CODE(0,6,2)
#define KB_M			KB_CODE(0,6,1)

#define KB_F4			KB_CODE(1,6,4)
#define KB_U			KB_CODE(1,6,3)
#define KB_8			KB_CODE(1,6,2)
#define KB_J			KB_CODE(1,6,1)

#define KB_DASH			KB_CODE(0,7,4)
#define KB_COLON		KB_CODE(0,7,3)
#define KB_QUOTE		KB_CODE(0,7,2)
#define KB_SLASH		KB_CODE(0,7,1)

#define KB_F6			KB_CODE(1,7,4)
#define KB_P			KB_CODE(1,7,3)
#define KB_EQUALS		KB_CODE(1,7,2)
#define KB_SHIFT		KB_CODE(1,7,1)

#define KB_T			KB_CODE(0,8,4)
#define KB_H			KB_CODE(0,8,3)
#define KB_N			KB_CODE(0,8,2)
#define KB_SPACE		KB_CODE(0,8,1)

#define KB_F3			KB_CODE(1,8,4)
#define KB_R			KB_CODE(1,8,3)
#define KB_6			KB_CODE(1,8,2)
#define KB_B			KB_CODE(1,8,1)

//row 9 is all empty

#define KB_LMENU		KB_CODE(0,10,4)
#define KB_PAD_4		KB_CODE(0,10,3)
#define KB_PAD_7		KB_CODE(0,10,2)
#define KB_F11			KB_CODE(0,10,1)

#define KB_F12			KB_CODE(1,10,4)
#define KB_PAD_1		KB_CODE(1,10,3)
#define KB_PAD_2		KB_CODE(1,10,2)
#define KB_PAD_8		KB_CODE(1,10,1)

#define KB_PAD_MINUS	KB_CODE(0,11,4)
#define KB_PAD_PLUS		KB_CODE(0,11,3)
#define KB_PAD_ASTERISK	KB_CODE(0,11,2)
#define KB_PAD_9		KB_CODE(0,11,1)

#define KB_F10			KB_CODE(1,11,4)
#define KB_PAD_5		KB_CODE(1,11,3)
#define KB_PAD_SLASH	KB_CODE(1,11,2)
#define KB_NUMLOCK		KB_CODE(1,11,1)

#define KB_TILDE		KB_CODE(0,12,4)
#define KB_PAD_6		KB_CODE(0,12,3)
#define KB_PAUSE		KB_CODE(0,12,2)
#define KB_SPACE2		KB_CODE(0,12,1)

#define KB_F9			KB_CODE(1,12,4)
#define KB_PAD_3		KB_CODE(1,12,3)
#define KB_PAD_DEL		KB_CODE(1,12,2)
#define KB_PAD_0		KB_CODE(1,12,1)

#endif

unsigned char keyb_raw[KBD_ROWS*2];
unsigned char keyb_raw_any;



void kb_init(void)
{
	memfill(keyb_raw,0,sizeof(keyb_raw));
	
	keyb_raw_any=0;
}



void kb_poll(void)
{
	keyb_raw_any=0;
	
	*((unsigned char*)0x4016)=0x05;

	for(_i=0;_i<KBD_ROWS;++_i)
	{
		*((unsigned char*)0x4016)=0x04;

		_n=(*((unsigned char*)0x4017)^0xff)&0x1e;
		keyb_raw[0+_i]=_n;
		keyb_raw_any|=_n;
		
		*((unsigned char*)0x4016)=0x06;

		_n=(*((unsigned char*)0x4017)^0xff)&0x1e;
		
		if(_i==9) _n&=~0x02;	//reset Bit4 in Row9, which is the sign of the expanded rows (not emulated anywhere as of 02'23)

		keyb_raw[KBD_ROWS+_i]=_n;
		keyb_raw_any|=_n;
	}
}



unsigned char __fastcall__ kb_state(unsigned int key_code)
{
	return keyb_raw[key_code>>8]&key_code;
}



unsigned char __fastcall__ kb_is_any(void)
{
	return keyb_raw_any;
}
